<?PHP

/**************************************
    Webutler V3.1 - www.webutler.de
    Copyright (c) 2008 - 2015
    Autor: Sven Zinke
    Free for any use
    Lizenz: GPL
**************************************/

require_once dirname(dirname(dirname(dirname(dirname(dirname(__FILE__)))))).'/includes/loader.php';

$webutlerckplugin = new WebutlerAdminClass;
$webutlerckplugin->config = $webutler_config;

if(!$webutlerckplugin->checkadmin())
    exit('no access');

require_once $webutlerckplugin->config['server_path'].'/admin/system/lang/'.$_SESSION['loggedin']['userlang'].'.php';
require_once $webutlerckplugin->config['server_path'].'/content/grids/mygrids_lang.php';

header('Content-type: application/javascript');
header('Cache-Control: no-store, no-cache, must-revalidate'); // HTTP 1.1
header('Cache-Control: post-check=0, pre-check=0, false'); // HTTP 1.0
header('Expires: Sat, 26 Jul 1997 05:00:00 GMT');
header('Pragma: no-cache');

function clean_file($content) {
	$content = preg_replace('#<!-- begin_content -->#Usi', '', $content);
	$content = preg_replace('#<!-- end_content -->#Usi', '', $content);
	$content = str_replace('wb_gridelement', '', $content);
	$content = str_replace(array('wb_gridelement', 'wb_contentelement'), array('', ''), $content);
	$content = str_replace(array("\r\n", "\r"), "\n", $content);
	
	$lines = explode("\n", $content);
	$new_lines = array();

	foreach($lines as $i => $line) {
		if(!empty($line)) {
			$new_lines[] = trim($line);
		}
	}
	$newcontent = implode($new_lines);
	$newcontent = str_replace("'", "&#39;", $newcontent);
	
	return $newcontent;
}

function remove_nested($html) {
	$html = str_replace('&nbsp;', '&amp;nbsp;', $html);
	
	$dom = new DOMDocument;
	$dom->preserveWhiteSpace = false;
	$dom->formatOutput = false;
	$dom->loadHTML('<?xml encoding="UTF-8">'.$html);
	$dom->encoding = 'UTF-8';

	$xpath = new DOMXPath($dom);
	$nodes = $xpath->query("//div[(contains(@class, 'wb_gridelement') and not(contains(@class, ' '))) or (contains(@class, 'wb_contentelement') and not(contains(@class, ' ')))]");
	
	foreach($nodes as $i => $dupe)
	{
		while($dupe->childNodes->length)
		{
			$child = $dupe->firstChild;
			$dupe->removeChild($child);
			$dupe->parentNode->appendChild($child);
		}	
		$dupe->parentNode->removeChild($dupe);
	}

	$savedbody = $xpath->query('/html/body');
	$result = $dom->saveHTML($savedbody->item(0));
	$result = str_replace('&amp;nbsp;', '&nbsp;', $result);
	return $result;
}

function load_grids($serverpath, $elements) {
	$grids = array();
	
	foreach($elements as $part => $arrays) {
		if($part != 1) {
			if($part == 2 || $part == 3 || $part == 4 || $part == 5) {
				$gridgroup = constant('_WBLANGADMIN_WIN_GRIDS_'.$part.'_');
				$setto = 'base';
			}
			else {
				$gridgroup = defined('_WBLANGGRIDS_'.$part.'_') ? constant('_WBLANGGRIDS_'.$part.'_') : _WBLANGADMIN_WIN_GRIDS_OWN_;
				$setto = 'own';
			}
			
			$elms = array();
			foreach($arrays as $array) {
				$setasprozent = true;
				if($setto == 'own') {
					foreach($array as $prozent) {
						if(!is_numeric($prozent)) {
							$setasprozent = false;
							break;
						}
					}
				}
				$previews = array();
				foreach($array as $prozent) {
					if($setasprozent) {
						$width = ($prozent*3).'px';
						$value = $prozent.'%';
					}
					else {
						$width = intval(300/count($array)).'px';
						$value = $prozent;
					}
					$previews[] = '<div class="wbcke_grid_col" style="width: '.$width.'">'.$value.'</div>';
				}
				
				$filename = $part.'_'.implode('_', $array).'.grd';
				$filecontent = file_get_contents($serverpath.'/content/grids/elements/'.$filename);
				$filecontent = remove_nested($filecontent);
				$filecontent = str_replace(array('<body>', '</body>'), array('', ''), $filecontent);
				$filecontent = clean_file($filecontent);
				
				$elms[] = "\t{\n\t\tpreview: '".implode('', $previews)."',\n\t\thtml: '".$filecontent."'\n\t}";
			}
			$grids[] = "{\n\ttitle: '".$gridgroup."',\n\telements: [\n".implode(",\n", $elms)."\n]\n}";
		}
	}
    
	return $grids;
}

$elements = $webutlerckplugin->loadgrids();

$grids = load_grids($webutlerckplugin->config['server_path'], $elements);

?>

var wbcke_setmargintop = '<?PHP echo $webutlerckplugin->config['insertmargin']; ?>';
var wbcke_setmargintext = '<?PHP echo _WBLANGADMIN_GRID_INSERT_PROMT_; ?>';
var wbcke_gridfiles = [
<?PHP echo implode(",\n", $grids); ?>
];


